/*
 *                            ANSI.SYS
 *              ANSI HELP FOR "C" LANGUAGE COMPILER
 *
 * ROUTINES: GOTOXY(X,Y)    POSITION CURSOR LINE,COLUMN
 *           CLEARSCR()     CLEAR SCREEN
 *           SETCOLOR(S)    SET TEXT COLOR
 *           CLEAREOL()     CLEAR TO END OF LINE
 */
#include "globals.h"

#define ESC        0x1b           /* ESCAPE CODE              */
#define NORMCOLOR  "[00m"
#define BLACK      "[30;30m"
#define RED        "[30;31m"
#define GREEN      "[30;32m"
#define YELLOW     "[30;33m"
#define BLUE       "[30;34m"
#define MAGENTA    "[30;35m"
#define CYAN       "[30;36m"
#define WHITE      "[30;37m"

#define  IAC		255
#define	WILL		251
#define	WONT		252
#define	TN_ECHO	  1

void echo_off(int s)
{
char temp[5];

  sprintf(temp,"%c%c%c",IAC,WILL,TN_ECHO);
  xprintf(s,temp);
}
void echo_on(int s)
{
char temp[5];

  sprintf(temp,"%c%c%c",IAC,WONT,TN_ECHO);
  xprintf(s,temp);
}

/*
 * POSTIONS THE CURSOR AT THE (LINE,COLUMN) SPECIFIED.
 */
void gotoxy (int s, int x,int y )
{
char temp[15];
		sprintf(temp,"%c[%u;%uH", ESC, x, y);
		xprintf(s,temp);
}
/*
 * CLEAR THE SCREEN
 */
void clearscr(int s)
{
char temp[15];

		sprintf(temp,"%c[2J", ESC);                /* CLEAR SCREEN ANSI */
		xprintf(s,temp);
}
/*
 * SET FORGROUND COLOR
 */
void setcolor(new_s,line)
int new_s;
char line[];
{
char temp[15];

		sprintf(temp,"%c%s", ESC, line);
		xprintf(new_s,temp);
}
/*
 * CLEAR TO END OF LINE
 */
void cleareol(int s)
{
char temp[15];

		 sprintf(temp,"%c[0K", ESC);
		 xprintf(s,temp);
}
